#
# @(#)Title.....POSTINO_ADM - administration for POSTINO_PRO
# @(#)Author....dada 18.10.96
# @(#)Version...1.30 20.11.96
#

######################################################################
# .A:CONFIGURATION
######################################################################

# uncomment next line for DEBUG mode
# $DEBUG="x";

%TIMEZONES=(
  "BST"                      => [ -8, 0],
  "CDT"                      => [ -5, 0],
  "CST"                      => [ -8, 0],
  "EDT"                      => [ +4, 0],
  "EST"                      => [-10, 0],
  "GMT"                      => [  0, 0],
  "IST"                      => [ -3, 0],
  "MDT"                      => [ +6, 0],
  "PDT"                      => [ +7, 0],
  "PST"                      => [ +8, 0],
  "MET DST"                  => [ -2, 0],
  "UT"                       => [  0, 0],
  "US Eastern Standard Time" => [ +5, 0],
  "\\\+-200"                 => [ -2, 0],
  "\\\+50000"                => [ +4, 0],
  "-400"                     => [ +4, 0],
);

@KNOWN_TIMEZONES=keys(%TIMEZONES);

%Month2Num = (
    'Jan', 0, 'Feb', 1, 'Mar', 2, 'Apr', 3, 'May', 4, 'Jun', 5, 'Jul', 6,
    'Aug', 7, 'Sep', 8, 'Oct', 9, 'Nov', 10, 'Dec', 11,
);
%WDay2Num = (
    'Sun', 0, 'Mon', 1, 'Tue', 2, 'Wed', 3, 'Thu', 4, 'Fri', 5, 'Sat', 6,
);

######################################################################
# .A:PROGRAM
######################################################################

use Win32::ODBC;
use Win32::Registry;

$|=1;

print "HTTP/1.0 200 OK\n" if $ENV{"PERLXS"}=~/PerlIS/i;
print "Content-type: text/html\n\n";

&ReadParse(*IN); # from cgi-lib.pl

$status=&PostinoInit;
if($status ne undef) {
  print "<HTML><HEAD><TITLE>500 - CGI ERROR</TTTLE></HEAD><BODY>\n";
  print "<H1>ERROR</H1><HR>Program not installed correctly.</BODY></HTML>";
  exit(0);
}

&printDEBUG("<HTML><HEAD><TITLE>$POSTINO{'Name'} $POSTINO{'Version'} DEBUG</TITLE></HEAD>".$POSTINO{'HTML_Body'});
print "<HTML><HEAD><TITLE>$POSTINO{'Name'} $POSTINO{'Version'}"; # standard part of the title

if($IN{"archive"} eq undef) {
  if($POSTINO{"DefaultArchive"} ne undef) {
    $arch="POSTINO"; 
  }
} else {
  $arch=$IN{"archive"};
}

&printDEBUG("loading archive $arch...<BR>\n");
$status=&PostinoLoadArchive($arch); 
if($status ne undef) {
  print "<HTML><HEAD><TITLE>500 - CGI ERROR</TTTLE></HEAD><BODY>\n";
  print "<H1>ERROR</H1><HR>Archive \"<B>$arch</B>\" not found.</BODY></HTML>";
  exit(0);
}

print " - Administration";
&printDoneWithHead;


######################################################################
# .A:NEW_ARCHIVE
######################################################################
if($IN{'create'} eq 'Create') {
  if($IN{'newarchive'} eq undef) {
    &printTitleLine("Administration");
    print $POSTINO{'HTML_Font'};
    print "Please specify a name for the new archive.";
    print "<A HREF=\"$POSTINO{'AdminURL'}\">Click here</A> to return to the main administration page.\n";
    &benchmark;
    exit(0);
  } else {
    ######################################################################
    # .A:NEW_ARCHIVE_SAVE
    ######################################################################
    if($IN{'save'} eq "    OK    ") {
      $archive=$IN{'newarchive'}; # for brevity 
      &printTitleLine("Creating archive \"$archive\"");
      # Open the registry
      $result=$main::HKEY_LOCAL_MACHINE->Open("SOFTWARE\\dada\\POSTINO\\Archives",$REG) || &dieERROR("Unable to open registry key");
      $result=$REG->Create($archive,$REGNEW) || &dieERROR("Unable to create registry key");
      $HTML_FontEnd=&EndHTML($IN{'HTML_Font'});
      $HTML_TitleFontEnd=&EndHTML($IN{'HTML_TitleFont'});
      $TitleEnd=&EndHTML($IN{'Title'});
      foreach $value ("Name","MSG_Path","MSG_Files",
                      "HTML_Title","HTML_TitleEnd","HTML_Font","HTML_FontEnd",
                      "HTML_File","HTML_Body","HTML_TitleFont","HTML_TitleFontEnd",
                      "DB_DSN","DB_Table","DB_Field_IDs","DB_Field_ParentIDs",
                      "DB_Field_Years","DB_Field_Months","DB_Field_Days",
                      "DB_Field_Hours","DB_Field_Minutes",
                      "DB_Field_Subjects","DB_Field_Names","DB_Field_Emails",
                      "DB_Field_Files","AliasFile",
                      "IMG_Void","IMG_Expand","IMG_Collapse") {
        &RegCreateValue($REGNEW,$value,REG_SZ,$IN{$value});
      }
      $REGNEW->Close();
      $REG->Close();
      print $POSTINO{'HTML_Font'};
      print "Configuration saved.\n";
      print "<A HREF=\"$POSTINO{'AdminURL'}\">Click here</A> to return to the main administration page.\n";
      &benchmark;
      exit(0);
    } else {
      ######################################################################
      # .A:NEW_ARCHIVE_FORM
      ######################################################################
      $archive=$IN{'newarchive'};
      for $defaultkey ("HTML_Body","HTML_Font","HTML_Title","HTML_TitleFont",
                       "IMG_Previous","IMG_Next","IMG_Void","IMG_Expand","IMG_Collapse") {
        $ARCHIVE{$defaultkey}=$POSTINO{$defaultkey};
      }
      $ARCHIVE{'DB_DSN'}="";
      $ARCHIVE{'DB_Table'}="";
      $ARCHIVE{'DB_Field_IDs'}="ID";
      $ARCHIVE{'DB_Field_ParentIDs'}="ParentID";
      $ARCHIVE{'DB_Field_Years'}="Year";
      $ARCHIVE{'DB_Field_Months'}="Month";
      $ARCHIVE{'DB_Field_Days'}="Day";
      $ARCHIVE{'DB_Field_Hours'}="Hour";
      $ARCHIVE{'DB_Field_Minutes'}="Minute";
      $ARCHIVE{'DB_Field_Subjects'}="Subject";
      $ARCHIVE{'DB_Field_Names'}="Name";
      $ARCHIVE{'DB_Field_Emails'}="Email";
      $ARCHIVE{'DB_Field_Files'}="File";
      $ARCHIVE{'Title'}=$archive;
      $ARCHIVE{'Path'}="";
      $ARCHIVE{'HTML_File'}="";
      $ARCHIVE{'Name'}=$archive;
      $ARCHIVE{'MSG_Files'}="*.msg";
      $ARCHIVE{'MSG_Path'}="";
      $ARCHIVE{'AliasFile'}="";
      &printTitleLine("Creating archive \"$archive\"");
      print "<FORM ACTION=\"$POSTINO{'AdminURL'}\" METHOD=post>\n";
      print "<TABLE><TD VALIGN=top>\n";
      print $POSTINO{'HTML_Font'};
      print "<B>General:</B><BR>\n";
      print "<TABLE>\n";
      &ConfigValue('Name of the archive','Name',*ARCHIVE);
      &ConfigValue('Messages directory','MSG_Path',*ARCHIVE);
      &ConfigValue('Messages files','MSG_Files',*ARCHIVE);
      &ConfigValue('HTML File','HTML_File',*ARCHIVE);
      &ConfigValue('Alias File','AliasFile',*ARCHIVE);
      print "</TABLE><P>\n";
      &ConfigDB(*ARCHIVE);
      &ConfigImages(*ARCHIVE);
      &ConfigHTML(*ARCHIVE);
      print "</TD></TABLE></CENTER>\n".
            "<INPUT TYPE=hidden NAME=newarchive VALUE=\"$IN{'newarchive'}\"> \n".
            "<INPUT TYPE=hidden NAME=create VALUE=Create> \n".
            "<INPUT TYPE=submit NAME=save VALUE=\"    OK    \"> \n".
            "<INPUT TYPE=submit NAME=save VALUE=Cancel> \n".
            "</CENTER>\n".
            "</FORM>\n";
      &benchmark;
      exit(0);    
    }    
  }
}


######################################################################
# .A:ARCHIVE_UPDATE
######################################################################
if($IN{'archive'} ne undef && $IN{'save'} ne "Cancel" 
&& $IN{"do"} eq "Update") {

  if($IN{'update'} eq undef) {
    ######################################################################
    # .A:ARCHIVE_UPDATE_FORM
    ######################################################################
    &printTitleLine("Updating archive \"$IN{'archive'}\"");
    $ARCHIVE{"DB_Table"}="[".$ARCHIVE{"DB_Table"}."]" if $ARCHIVE{"DB_Table"}=~/[^a-zA-Z0-9]/;    
    
    &PostinoConnectToODBC;

    print "$POSTINO{'HTML_Font'}\n";
    print "Archive <B>$IN{'archive'}</B> contains ";
    &execSQL("SELECT Max($ARCHIVE{'DB_Field_IDs'}) FROM $ARCHIVE{'DB_Table'};");
    $DB->FetchRow();
    &printDEBUG("FETCHROW OK<BR>\n");
    $myID=$DB->Data();
    $myID=0 if $myID eq undef;
    print "<B>$myID</B> records.<BR>\n";

    opendir(INBOX,$ARCHIVE{'MSG_Path'}) || print "ERROR OPENING DIR $ARCHIVE{'Path'}!<BR>\n";
    &printDEBUG("Reading files from <B>$ARCHIVE{'MSG_Path'}</B>...<BR>\n");
    @allfiles=readdir(INBOX);
    closedir(INBOX);
    $filespec="\^".$ARCHIVE{'MSG_Files'}."\$";
    $filespec=~s/\./\\\./g;
    $filespec=~s/\*/\.\*/g;
    &printDEBUG("grepping <B>$filespec</B>...<BR>\n");
    @msgfiles=grep(/$filespec/i,@allfiles);
    print "Directory <B>$ARCHIVE{'MSG_Path'}</B> contains <B>",($#msgfiles+1),"</B> files.<P>\n";
    print "<FORM ACTION=\"$POSTINO{'AdminURL'}\" METHOD=get>\n".
          "<INPUT TYPE=hidden NAME=archive VALUE=\"$IN{'archive'}\">\n".
          "<INPUT TYPE=hidden NAME=do VALUE=Update>\n".
          "<INPUT TYPE=submit NAME=update VALUE=\"Update\">\n";
    print "<P>Selective Updates:<P>\n".
          "<INPUT TYPE=submit NAME=update VALUE=\"Update aliases\"><P>\n".
          "<INPUT TYPE=submit NAME=update VALUE=\"Update timezones\"><P>\n".
          "</FORM><P>\n";
    print "<A HREF=\"$POSTINO{'AdminURL'}\">Click here</A> to return to the main administration page.\n";
    &benchmark;
    exit(0);

  } elsif($IN{'update'} eq 'Update') {
    ######################################################################
    # .A:ARCHIVE_UPDATE_NORMAL
    ######################################################################

    &printTitleLine("Updating archive \"$IN{'archive'}\"");

    $ARCHIVE{"DB_Table"}="[".$ARCHIVE{"DB_Table"}."]" if $ARCHIVE{"DB_Table"}=~/[^a-zA-Z0-9]/;
 
    &PostinoLoadAliases(*ALIASES);

    print $ARCHIVE{'HTML_Font'};

    &PostinoConnectToODBC;

    # get the fields in the database table
    &execSQL("SELECT * FROM $ARCHIVE{'DB_Table'};");
    $DB->FetchRow();
    &printDEBUG("getting field names...");
    @fields=$DB->FieldNames();
    &printDEBUG("<B>",$#fields,"</B> fields found.<BR>\n");

    # evtl. add the NewRecord field
    if(grep(/^NewRecord$/i,@fields)<=0) {
      &execSQL("ALTER TABLE $ARCHIVE{'DB_Table'} ".
               " ADD COLUMN NewRecord INTEGER;");
    }

    # set all NewRecord to 0
    &execSQL("UPDATE $ARCHIVE{'DB_Table'} SET NewRecord=0;");
    
    print "Found ";
    &execSQL("SELECT Max($ARCHIVE{'DB_Field_IDs'}) FROM $ARCHIVE{'DB_Table'};");
    $DB->FetchRow();
    &printDEBUG("FETCHROW OK<BR>\n");
    $myID=$DB->Data();
    $myID=0 if $myID eq undef;
    print "<B>$myID</B> records in the DB.<BR>\n";

    $msgi=0;
    @db_time=();
    opendir(INBOX,$ARCHIVE{'MSG_Path'}) || print "ERROR OPENING DIR $ARCHIVE{'Path'}!<BR>\n";
    &printDEBUG("Reading files from <B>$ARCHIVE{'MSG_Path'}</B>...<BR>\n");
    @allfiles=readdir(INBOX);
    closedir(INBOX);
    $filespec="\^".$ARCHIVE{'MSG_Files'}."\$";
    $filespec=~s/\./\\\./g;
    $filespec=~s/\*/\.\*/g;
    &printDEBUG("grepping <B>$filespec</B>...<BR>\n");
    @msgfiles=grep(/$filespec/i,@allfiles);
    print "Found <B>",($#msgfiles+1),"</B> files in the directory.<BR>\n";
    &execSQL("SELECT $ARCHIVE{'DB_Field_Files'} FROM $ARCHIVE{'DB_Table'};");
    undef %dbfiles;
    while($DB->FetchRow()) {
      $file=$DB->Data();
      $dbfile{$file}=1;
    }
    @newfiles=();
    print "Searching for new files\n";
    foreach $file (@msgfiles) {
      print " .";
      push(@newfiles,$file) if $dbfile{$file} eq undef;
    }
    print "<HR>";
    &printDEBUG(join("<BR>\n",@newfiles));
    print "Adding <B>",($#newfiles+1),"</B> records";    
    foreach $filename (@newfiles) {
      next if $filename eq ".";
      next if $filename eq "..";
      $mySUBJECT="";
      $myNAME="";
      $myEMAIL="";
      print " .";
      open(MSG,"<$ARCHIVE{'MSG_Path'}/$filename");
      $headers=1;
      while(<MSG>) {
        chop;
        # BODY START
        if(/^$/) {
          $headers=0;
          close(MSG);
        }
        if($headers eq 1) {
          # SUBJECT
          if(/^Subject:[\s\t]+/) {
            s/^Subject:[\s\t]+//i;
            $_=~s/^re: /Re: /i; # to avoid problem with threatening of Re and RE
            $mySUBJECT=$_;
          }
    
          # DATE
          if(/^Date:[\s\t]+/) {
            s/^Date:[\s\t]+//i;
            ($myTimeY,$myTimeM,$myTimeD,$myTimeHH,$myTimeMM)=&dateConvert($file, $_);
          }

          # FROM
          if(/^From:[\s\t]+/) {
            s/^From:[\s\t]+//i;
            # print "From: <B>$_</B><BR>";
            ($myNAME,$myEMAIL)=&emailConvert($_);
          }
        }
      }
      close(MSG);  
      $myID++;

      # add the message to DB
      $mySQL="INSERT INTO $ARCHIVE{'DB_Table'} ";
      $mySQL.="( $ARCHIVE{'DB_Field_IDs'}, $ARCHIVE{'DB_Field_ParentIDs'}, ".
              "$ARCHIVE{'DB_Field_Years'}, $ARCHIVE{'DB_Field_Months'}, ".
              "$ARCHIVE{'DB_Field_Days'}, $ARCHIVE{'DB_Field_Hours'}, ".
              "$ARCHIVE{'DB_Field_Minutes'}, $ARCHIVE{'DB_Field_Subjects'}, ".
              "$ARCHIVE{'DB_Field_Names'}, $ARCHIVE{'DB_Field_Emails'}, ".
              "$ARCHIVE{'DB_Field_Files'}, NewRecord) ";
      $mySQL.="VALUES ( $myID, 0";
      $mySQL.=", $myTimeY, $myTimeM, $myTimeD, $myTimeHH, $myTimeMM";
      $mySUBJECT=~s/\|/{pipe}/g;
      $mySUBJECT=~s/\'/\'\'/g;
      $mySUBJECT="(no subject)" if $mySUBJECT eq undef;
      $myEMAIL=~s/\'/\'\'/g;
      $myNAME=~s/\'/\'\'/g;
      $mySQL.=", '".$mySUBJECT."'";
      $mySQL.=", '".$myNAME."'";
      $mySQL.=", '".$myEMAIL."'";
      $mySQL.=", '".$filename."'";
      $mySQL.=", 1";
      $mySQL.=");";
      # print "<FONT COLOR=indianred>SQL:</FONT> $mySQL<BR>\n";

      &execSQL($mySQL);
    } 

    # threads messages
    #print "<HR>Threading messages (new method)";
    #$newTable=$ARCHIVE{'DB_Table'}."_Topic";
    #$newTable=~s/^\[(.*)\](.*)$/$1$2/;
    #$newTable="[".$newTable."]" if $1 && $2;
    #&execSQL("CREATE TABLE $newTable (ID INTEGER, Topic TEXT(255));");
    #&execSQL("UPDATE $newTable ".
    #         " SET Topic=$ARCHIVE{'DB_Table'}.$ARCHIVE{'DB_Field_Subjects'} ".
    #         " GROUP BY $ARCHIVE{'DB_Table'}.$ARCHIVE{'DB_Field_Subjects'} ".
    #         " ORDER BY $ARCHIVE{'DB_Field_Years'} ASC, ".
    #         " $ARCHIVE{'DB_Field_Months'} ASC, $ARCHIVE{'DB_Field_Days'} ASC, ".
    #         " $ARCHIVE{'DB_Field_Hours'} ASC, $ARCHIVE{'DB_Field_Minutes'} ASC;");
    

    print "<HR>Threading messages";
    &execSQL("SELECT $ARCHIVE{'DB_Field_IDs'}, $ARCHIVE{'DB_Field_Subjects'} ".
             " FROM $ARCHIVE{'DB_Table'} ".
             " WHERE NewRecord=1 ".
             " GROUP BY $ARCHIVE{'DB_Field_Subjects'}, $ARCHIVE{'DB_Field_IDs'} ".
             " ORDER BY $ARCHIVE{'DB_Field_Years'} ASC, ".
             " $ARCHIVE{'DB_Field_Months'} ASC, $ARCHIVE{'DB_Field_Days'} ASC, ".
             " $ARCHIVE{'DB_Field_Hours'} ASC, $ARCHIVE{'DB_Field_Minutes'} ASC;");
    undef %odbc_subj;
    while($DB->FetchRow()) {
      ($id,$subj)=$DB->Data($ARCHIVE{'DB_Field_IDs'},$ARCHIVE{'DB_Field_Subjects'});
      $odbc_subj{$id}=$subj;
      $odbc_subj{$id}=~s/\|/\{pipe\}/g;
      $odbc_subj{$id}=~s/\'/\'\'/g;
    }
    foreach $id (keys(%odbc_subj)) {
      print " .";
      &execSQL("SELECT $ARCHIVE{'DB_Field_IDs'} FROM $ARCHIVE{'DB_Table'} ".
               " WHERE $ARCHIVE{'DB_Field_ParentIDs'}=0 ".
               " AND ($ARCHIVE{'DB_Field_Subjects'} LIKE 'Re: $odbc_subj{$id}' ".
               " OR $ARCHIVE{'DB_Field_Subjects'} LIKE '$odbc_subj{$id}') ".
               " ORDER BY $ARCHIVE{'DB_Field_Years'} ASC, ".
               " $ARCHIVE{'DB_Field_Months'} ASC, $ARCHIVE{'DB_Field_Days'} ASC, ".
               " $ARCHIVE{'DB_Field_Hours'} ASC, $ARCHIVE{'DB_Field_Minutes'} ASC;");

      $DB->FetchRow();
      $fatherID=$DB->Data();
      &execSQL("UPDATE $ARCHIVE{'DB_Table'} ".
               " SET $ARCHIVE{'DB_Field_ParentIDs'}=$id ".
               " WHERE $ARCHIVE{'DB_Field_ParentIDs'}=0 ".
               " AND $ARCHIVE{'DB_Field_IDs'}<>$id ".
               (($fatherID eq undef) ? "" : " AND $ARCHIVE{'DB_Field_IDs'}<>$fatherID ").
               " AND ($ARCHIVE{'DB_Field_Subjects'} LIKE 'Re: $odbc_subj{$id}' ".
               " OR $ARCHIVE{'DB_Field_Subjects'} LIKE '$odbc_subj{$id}');");
    }

    print "<HR>Building Subject/Sender FirstLetter indexes...\n";
    foreach $myFIELD ($ARCHIVE{'DB_Field_Subjects'},$ARCHIVE{'DB_Field_Names'}) {
      if(grep(/^${myFIELD}_FirstLetter$/i,@fields)<=0) {
        &execSQL("ALTER TABLE $ARCHIVE{'DB_Table'} ".
                 " ADD COLUMN ${myFIELD}_FirstLetter TEXT(1);");
      }
      $mySQL="UPDATE $ARCHIVE{'DB_Table'} SET ${myFIELD}_FirstLetter=$myFIELD ".
             " WHERE $myFIELD LIKE \'A%\' ";
      foreach $letter (B..Z) {
        $mySQL.=" OR $myFIELD LIKE \'$letter%\' ";
      }
      #$mySQL.=") AND ${myFIELD}_FirstLetter='' ";
      $mySQL.=" AND NewRecord=1 ";
      $mySQL.=";";
      &execSQL($mySQL);

      $mySQL="UPDATE $ARCHIVE{'DB_Table'} SET ${myFIELD}_FirstLetter=\'!\' ".
             " WHERE $myFIELD NOT LIKE \'A%\' ";
      foreach $letter (B..Z) {
        $mySQL.=" AND $myFIELD NOT LIKE \'$letter%\' ";
      }
      #$mySQL.=") AND ${myFIELD}_FirstLetter='' ";
      $mySQL.=" AND NewRecord=1 ";
      $mySQL.=";";
      &execSQL($mySQL);
    }
    print "Done<BR>\n";

    # retrieve number of records in the DB and actual time
    ($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdst)=localtime(time);
    $mon++;
    $POSTINO_LAST_UPDATE=sprintf("%02d/%02d/%02d %02d:%02d:%02d",$day,$mon,$year,$hour,$min,$sec);
    $POSTINO_MESSAGES=0;
    &execSQL("SELECT $ARCHIVE{'DB_Field_IDs'} FROM $ARCHIVE{'DB_Table'};");
    while($DB->FetchRow()) {
      $POSTINO_MESSAGES++;
    }
    $DB->Close();

    # substitute (fake-SSI) update time and messages number in the HTML doc
    if(open(HTML_IN,"<$ARCHIVE{'HTML_File'}")) {
      open(HTML_OUT,">$ARCHIVE{'HTML_File'}.new");
      while(<HTML_IN>) {
        s/(<!--POSTINO_LAST_UPDATE-->).*(<!--POSTINO_LAST_UPDATE_END-->)/$1$POSTINO_LAST_UPDATE$2/i;
        s/(<!--POSTINO_MESSAGES-->).*(<!--POSTINO_MESSAGES_END-->)/$1$POSTINO_MESSAGES$2/i;
        print HTML_OUT $_;
      }
      close(HTML_IN);
      close(HTML_OUT);
      if(unlink($ARCHIVE{'HTML_File'})) {
        rename("$ARCHIVE{'HTML_File'}.new",$ARCHIVE{'HTML_File'});
      }
    }
    print "<HR>\n";
    print "Update complete. ";
    print "<A HREF=\"$POSTINO{'AdminURL'}\">Click here</A> to return to the main administration page.\n";
    &benchmark;
  }

  ######################################################################
  # .A:ARCHIVE_UPDATE_ALIAS
  ######################################################################
  elsif($IN{'update'} eq "Update aliases") {
    &printTitleLine("Updating archive \"$IN{'archive'}\"");

    $ARCHIVE{"DB_Table"}="[".$ARCHIVE{"DB_Table"}."]" if $ARCHIVE{"DB_Table"}=~/[^a-zA-Z0-9]/;

    # read in the ALIASES
    &PostinoLoadAliases(*ALIASES);
    
    print $ARCHIVE{'HTML_Font'};
 
    &PostinoConnectToODBC;
    
    foreach $alias (keys %ALIASES) {
      &execSQL("UPDATE $ARCHIVE{'DB_Table'} ".
               " SET $ARCHIVE{'DB_Field_Names'}='$ALIASES{$alias}' ".
               " WHERE $ARCHIVE{'DB_Field_Names'}='$alias';");
    }
    $DB->Close();
    print "Aliases applied. ";
    print "<A HREF=\"$POSTINO{'AdminURL'}\">Click here</A> to return to the main administration page.\n";
    &benchmark();
  }

  ######################################################################
  # .A:ARCHIVE_UPDATE_TIMEZONES
  ######################################################################
  elsif($IN{'update'} eq "Update timezones") {

    &printTitleLine("Updating archive \"$IN{'archive'}\"");

    $ARCHIVE{"DB_Table"}="[".$ARCHIVE{"DB_Table"}."]" if $ARCHIVE{"DB_Table"}=~/[^a-zA-Z0-9]/;

    # read in the ALIASES
    &PostinoLoadAliases(*ALIASES);
    
    print $ARCHIVE{'HTML_Font'};
 
    &PostinoConnectToODBC;
    
    &execSQL("SELECT $ARCHIVE{'DB_Field_Files'} FROM $ARCHIVE{'DB_Table'};");
    while($DB->FetchRow()) {
      $file=$DB->Data();
      push(@files,$file);
    }
    print "Found <B>",$#files+1,"</B> records in the DB.<BR>\n";
    print "Updating timezones ";
    foreach $file (@files) {
      print ". ";
      open(MSG,"<$ARCHIVE{'MSG_Path'}/$file");
      $headers=1;
      while(<MSG>) {
        chop;
        # BODY START
        if(/^$/) {
          $headers=0;
          close(MSG);
        }
        if($headers eq 1) {

          # DATE
          if(/^Date:[\s\t]+/) {
            s/^Date:[\s\t]+//i;
            ($myTimeY,$myTimeM,$myTimeD,$myTimeHH,$myTimeMM)=&dateConvert($file, $_);
          }
        }
      }
      close(MSG);  
      &execSQL("UPDATE $ARCHIVE{'DB_Table'} ".
               " SET $ARCHIVE{'DB_Field_Years'}=$myTimeY, ".
               " $ARCHIVE{'DB_Field_Months'}=$myTimeM, ".
               " $ARCHIVE{'DB_Field_Days'}=$myTimeD, ".
               " $ARCHIVE{'DB_Field_Hours'}=$myTimeHH, ".
               " $ARCHIVE{'DB_Field_Minutes'}=$myTimeMM ".
               " WHERE $ARCHIVE{'DB_Field_Files'}='$file';");
    }

    $DB->Close();
    print "<HR>\n";
    print "Timezones updated. ";
    print "<A HREF=\"$POSTINO{'AdminURL'}\">Click here</A> to return to the main administration page.\n";
    &benchmark();
  }
}



######################################################################
# .A:MAIN_ADMIN_PAGE
######################################################################
if($IN{'archive'} eq undef || $IN{'save'} eq "Cancel") {
  &printTitleLine("Administration");

  print "<FORM ACTION=\"$POSTINO{'AdminURL'}\" METHOD=get>\n".
        "<TABLE><TD VALIGN=top> $POSTINO{'HTML_Font'} Archives:<BR>\n";

  @archives=&PostinoGetArchives;
  print "<SELECT NAME=archive SIZE=",$#archives+1,">\n";
  foreach $a (@archives) {
    print "<OPTION ";
    print " SELECTED " if $a eq $POSTINO{'DefaultArchive'};
    print " VALUE=\"$a\">$a\n";
  }

# HTML_BEGIN
  print <<HTML_END;
    </SELECT>
    </TD><TD VALIGN=top ALIGN=center>
    <INPUT TYPE=submit NAME=do VALUE=Configure>
    <P> <INPUT TYPE=submit NAME=do VALUE=Update>
    <P> <INPUT TYPE=submit NAME=do VALUE=Delete>
    </TD>
    <TD VALIGN=top ALIGN=center>
    <INPUT TYPE=submit NAME=do VALUE="Set as default">
    <P> <INPUT TYPE=submit NAME=do VALUE="Modify records">
    </TD>
    <TR>
    <TD>$POSTINO{'HTML_Font'}Default Archive: <B>$POSTINO{'DefaultArchive'}</B><P></TD><TR>
    <TD>$POSTINO{'HTML_Font'}New Archive:<BR><INPUT TYPE=text NAME=newarchive SIZE=20> 
	<INPUT TYPE=submit NAME=create VALUE=Create><BR>
    </TD><TD>&nbsp;&nbsp;&nbsp;</TD>
    </TABLE></FORM>
HTML_END
  &benchmark;
  exit(0);

} else {

  ######################################################################
  # .A:DEFAULT_ARCHIVE
  ######################################################################
  if($IN{'do'} eq "Set as default") {
    $archive=$IN{"archive"};
    &printTitleLine("Administration");
    print $POSTINO{'HTML_Font'};
    $result=$main::HKEY_LOCAL_MACHINE->Open("SOFTWARE\\dada\\POSTINO",$REGpostino);
    if($result eq undef) {
      print "<FONT COLOR=red>ERROR</FONT>: Unable to delete registry key! ";
    } else {
      $result=$REGpostino->SetValueEx("DefaultArchive",0,REG_SZ,$archive);
    }
    print "Configuration saved. \n";
    print "<A HREF=\"$POSTINO{'AdminURL'}\">Click here</A> to return to the main administration page.\n";
    &benchmark;
    exit(0);
  }

  ######################################################################
  # .A:ARCHIVE_DELETE
  ######################################################################
  if($IN{'do'} eq "Delete") {
    if($IN{'delete'} eq "    OK    ") {
      $archive=$IN{"archive"};
      &printTitleLine("Deleting archive \"$archive\"");
      print $POSTINO{'HTML_Font'};
      $result=$main::HKEY_LOCAL_MACHINE->DeleteKey("SOFTWARE\\dada\\POSTINO\\Archives\\$archive");
      if($result eq undef) {
        print "<FONT COLOR=red>ERROR</FONT>: Unable to delete registry key! ";
      } else {
        print "Archive \"$archive\" successfully deleted. ";
      }
      print "<A HREF=\"$POSTINO{'AdminURL'}\">Click here</A> to return to the main administration page.\n";
      &benchmark;
      exit(0);
    } else {
      $archive=$IN{'archive'};
      &printTitleLine("Deleting archive \"$archive\"");
# HTML_BEGIN
      print <<HTML_END;
	    <FORM ACTION="$POSTINO{'AdminURL'}" METHOD=post>
        $POSTINO{'HTML_Font'};
        <B>Are you sure you want to delete the archive "$archive" ? </B><BR>
        <P><CENTER>
        <INPUT TYPE=hidden NAME=archive VALUE="$archive">
        <INPUT TYPE=hidden NAME=do VALUE=Delete>
        <INPUT TYPE=submit NAME=delete VALUE="    OK    ">
        <INPUT TYPE=submit NAME=save VALUE=Cancel>
        </CENTER>
        </FORM>
HTML_END
      &benchmark;
      exit(0);    
    }
  }

  ######################################################################
  # .A:ARCHIVE_CONFIGURATION_FORM
  ######################################################################
  if($IN{'do'} eq "Configure") {
    &printTitleLine("Archive \"$IN{'archive'}\" Configuration");
    print "<FORM ACTION=\"$POSTINO{'AdminURL'}\" METHOD=post>\n";
    print "<TABLE><TD VALIGN=top>\n";
    # @archives=&PostinoGetArchives;
    print $POSTINO{'HTML_Font'};
    print "<B>General:</B><BR>\n";
    print "<TABLE>\n";
    &ConfigValue('Name of the archive','Name',*ARCHIVE);
    &ConfigValue('Messages directory','MSG_Path',*ARCHIVE);
    &ConfigValue('Messages files','MSG_Files',*ARCHIVE);
    &ConfigValue('HTML File','HTML_File',*ARCHIVE);
    &ConfigValue('Alias File','AliasFile',*ARCHIVE);
    print "</TABLE>\n";
    print "<P>\n";
    &ConfigDB(*ARCHIVE);
    &ConfigImages(*ARCHIVE);
    &ConfigHTML(*ARCHIVE);
# HTML_BEGIN
    print <<HTML_END;
	  </TD></TABLE>
      <CENTER>
      <INPUT TYPE=hidden NAME=archive VALUE="$IN{'archive'}">
      <INPUT TYPE=submit NAME=save VALUE="    OK    ">
      <INPUT TYPE=submit NAME=save VALUE=Cancel>
      </CENTER>
      </FORM>
HTML_END
    &benchmark;
    exit(0);    
  }

  ######################################################################
  # .A:ARCHIVE_CONFIGURATION_SAVE
  ######################################################################
  if($IN{'save'} eq "    OK    ") {
    &printTitleLine("Archive \"$IN{'archive'}\" Configuration");
    # Open the registry
    $archive=$IN{'archive'}; # for brevity
    $result=$main::HKEY_LOCAL_MACHINE->Open("SOFTWARE\\dada\\POSTINO\\Archives\\$archive",$REG) || &dieERROR("Unable to open registry key");
    $result=$REG->GetValues($values) || &dieERROR("Unable to get registry values");
    $IN{'HTML_FontEnd'}=&EndHTML($IN{'HTML_Font'});
    $IN{'HTML_TitleFontEnd'}=&EndHTML($IN{'HTML_TitleFont'});
    $IN{'HTML_TitleEnd'}=&EndHTML($IN{'HTML_Title'});
    foreach $value ("Name","HTML_Title","HTML_TitleEnd","HTML_Font","HTML_FontEnd",
                    "HTML_File","HTML_Body","HTML_TitleFont","HTML_TitleFontEnd",
                    "DB_DSN","DB_Table","DB_Field_IDs","DB_Field_ParentIDs",
                    "DB_Field_Years","DB_Field_Months","DB_Field_Days",
                    "DB_Field_Hours","DB_Field_Minutes",
                    "DB_Field_Subjects","DB_Field_Names","DB_Field_Emails",
                    "DB_Field_Files","AliasFile",
                    "IMG_Previous","IMG_Next","IMG_Void","IMG_Expand","IMG_Collapse",
                    "MSG_Path","MSG_Files") {
      &RegUpdateValue($REG,$values,$value,REG_SZ,$IN{$value});
    }
    $REG->Close();
    print $POSTINO{'HTML_Font'};
    print "Configuration saved.\n";
    print "<A HREF=\"$POSTINO{'AdminURL'}\">Click here</A> to return to the main administration page.\n";
    &benchmark;
    exit(0);
  }


  ######################################################################
  # .A:ARCHIVE_MODIFY_RECORDS
  ######################################################################
  if($IN{"do"} eq "Modify records") {

    &printTitleLine("Modify records of \"$IN{'archive'}\"");

    $ARCHIVE{"DB_Table"}="[".$ARCHIVE{"DB_Table"}."]" if $ARCHIVE{"DB_Table"}=~/[^a-zA-Z0-9]/;

    # read in the ALIASES
    &PostinoLoadAliases(*ALIASES);

    print $POSTINO{'HTML_Font'};
 
    &PostinoConnectToODBC;

    if($IN{'number'} ne undef || $IN{'file'} ne undef || $IN{'record'} ne undef) {

      if($IN{'number'} ne undef) {
        $myWHERE=" WHERE $ARCHIVE{'DB_Field_IDs'}=$IN{'number'} ";
      } else {
        $myWHERE=" WHERE $ARCHIVE{'DB_Field_Files'}='$IN{'file'}' ";
      }

      if($IN{'record'} eq 'Save record') {
        $myWHERE=" WHERE $ARCHIVE{'DB_Field_IDs'}=$IN{$ARCHIVE{'DB_Field_IDs'}} ";
        # update numeric fields
        foreach $field ($ARCHIVE{'DB_Field_ParentIDs'},
                        $ARCHIVE{'DB_Field_Years'},$ARCHIVE{'DB_Field_Months'},
                        $ARCHIVE{'DB_Field_Days'},$ARCHIVE{'DB_Field_Hours'},
                        $ARCHIVE{'DB_Field_Minutes'}) {
          &execSQL("UPDATE $ARCHIVE{'DB_Table'} ".
                   "SET $field=$IN{$field} ".
                   $myWHERE.";");
        }
        # and text fields
        foreach $field ($ARCHIVE{'DB_Field_Subjects'},$ARCHIVE{'DB_Field_Names'},
                        $ARCHIVE{'DB_Field_Emails'},$ARCHIVE{'DB_Field_Files'}) { 
          &execSQL("UPDATE $ARCHIVE{'DB_Table'} ".
                   "SET $field='$IN{$field}' ".
                   $myWHERE.";");
        }          
        # get the fields in the database table
        &execSQL("SELECT * FROM $ARCHIVE{'DB_Table'};");
        $DB->FetchRow();
        &printDEBUG("getting field names...");
        @fields=$DB->FieldNames();

        # update firstletters index
        foreach $myFIELD ($ARCHIVE{'DB_Field_Names'},$ARCHIVE{'DB_Field_Subjects'}) {
          # eventually add field if is not there
          if(grep(/^${myFIELD}_FirstLetter$/i,@fields)<=0) {
            &execSQL("ALTER TABLE $ARCHIVE{'DB_Table'} ".
                     " ADD COLUMN ${myFIELD}_FirstLetter TEXT(1);");
          }
          $mySQL="UPDATE $ARCHIVE{'DB_Table'} SET ${myFIELD}_FirstLetter=$myFIELD ".
                 $myWHERE." AND ($myFIELD LIKE \'A%\' ";
          foreach $letter (B..Z) {
            $mySQL.=" OR $myFIELD LIKE \'$letter%\' ";
          }
          $mySQL.=");";
          &execSQL($mySQL);

          $mySQL="UPDATE $ARCHIVE{'DB_Table'} SET ${myFIELD}_FirstLetter=\'!\' ".
                 $myWHERE." AND ($myFIELD NOT LIKE \'A%\' ";
          foreach $letter (B..Z) {
            $mySQL.=" AND $myFIELD NOT LIKE \'$letter%\' ";
          }
          $mySQL.=");";
          &execSQL($mySQL);
        }
      }

      &execSQL("SELECT * FROM $ARCHIVE{'DB_Table'} ".$myWHERE.";");
      $DB->FetchRow();
      %msg=$DB->DataHash();
      # print "<HR>\n";
      print "<FORM ACTION=\"$POSTINO{'AdminURL'}\">\n".
            "<INPUT TYPE=hidden NAME=do VALUE=\"Modify records\">\n".
            "<INPUT TYPE=hidden NAME=archive VALUE=\"$IN{'archive'}\">\n".
            "<INPUT TYPE=submit NAME=record VALUE=\"Save record\">\n".
            "<TABLE>\n";

            # not yet...
            # "<INPUT TYPE=submit NAME=record VALUE=\"Delete ONLY record\">\n".
            # "<INPUT TYPE=submit NAME=record VALUE=\"Delete record AND file\">\n".

      &ConfigValue($ARCHIVE{'DB_Field_IDs'},$ARCHIVE{'DB_Field_IDs'},*msg,4);
      print  "<TR><TD>$POSTINO{'HTML_Font'}";	    
	  if($msg{$ARCHIVE{'DB_Field_ParentIDs'}}!=0) {
            print &callMe("number=$msg{$ARCHIVE{'DB_Field_ParentIDs'}}",$ARCHIVE{'DB_Field_ParentIDs'});
          } else {
	    print $ARCHIVE{'DB_Field_ParentIDs'};
	  }
	  print ":</TD><TD><INPUT TYPE=text NAME=\"$ARCHIVE{'DB_Field_ParentIDs'}\" ".
	        " VALUE=\"$msg{$ARCHIVE{'DB_Field_ParentIDs'}}\" SIZE=4>\n".
	        "</TD><TR><TD>$POSTINO{'HTML_Font'}$ARCHIVE{'DB_Field_Days'}/$ARCHIVE{'DB_Field_Months'}/$ARCHIVE{'DB_Field_Years'}: \n".
		"</TD><TD><INPUT TYPE=text NAME=\"$ARCHIVE{'DB_Field_Days'}\" ".
	        " VALUE=\"$msg{$ARCHIVE{'DB_Field_Days'}}\" SIZE=2> / \n".
                " <INPUT TYPE=text NAME=\"$ARCHIVE{'DB_Field_Months'}\" ".
	        " VALUE=\"$msg{$ARCHIVE{'DB_Field_Months'}}\" SIZE=2> / \n".
                " <INPUT TYPE=text NAME=\"$ARCHIVE{'DB_Field_Years'}\" ".
	        " VALUE=\"$msg{$ARCHIVE{'DB_Field_Years'}}\" SIZE=2>\n".
	        "</TD><TR><TD>$POSTINO{'HTML_Font'}$ARCHIVE{'DB_Field_Hours'}/$ARCHIVE{'DB_Field_Minutes'}: \n".
		"</TD><TD><INPUT TYPE=text NAME=\"$ARCHIVE{'DB_Field_Hours'}\" ".
	        " VALUE=\"$msg{$ARCHIVE{'DB_Field_Hours'}}\" SIZE=2> : \n".
                " <INPUT TYPE=text NAME=\"$ARCHIVE{'DB_Field_Minutes'}\" ".
	        " VALUE=\"$msg{$ARCHIVE{'DB_Field_Minutes'}}\" SIZE=2>\n".
	        "</TD><TR>\n";
          &ConfigValue($ARCHIVE{'DB_Field_Subjects'},$ARCHIVE{'DB_Field_Subjects'},*msg,60);
	  print "<TR>\n";
          &ConfigValue($ARCHIVE{'DB_Field_Names'},$ARCHIVE{'DB_Field_Names'},*msg,60);
          print "<TR>\n";
          &ConfigValue($ARCHIVE{'DB_Field_Emails'},$ARCHIVE{'DB_Field_Emails'},*msg,60);
          print "<TR>\n";
          &ConfigValue($ARCHIVE{'DB_Field_Files'},$ARCHIVE{'DB_Field_Files'},*msg,60);
          print "<TR>\n";
          print "<TD COLSPAN=2>$POSTINO{'HTML_Font'}Message content:<BR>\n";
          print "<TEXTAREA ROWS=25 COLS=80>\n";
          open(MSG,$ARCHIVE{'MSG_Path'}."/".$msg{$ARCHIVE{'DB_Field_Files'}});
          while(<MSG>) {
            print;
          }
          close(MSG);
          print "</TEXTAREA>\n";
          print "</TD>\n";
          print "</TABLE>\n";
	} else {
      # adjust START/LIMIT
      $IN{"limit"}=50 if $IN{"limit"} eq undef;
      &execSQL("SELECT * FROM $ARCHIVE{'DB_Table'};");
      # $records=$DB->RowCount();
      $records=0;
      while($DB->FetchRow()) {
        $records++;
      }
      if($IN{"max"} ne undef) {
        $IN{"max"}=$records if $IN{"max"}>$records;
        $IN{"start"}=1 if $IN{"start"}<1;
        $IN{"start"}=$records if $IN{"start"}>$records;
        $IN{"limit"}=$IN{"max"}-$IN{"start"};
      }
  
      if($IN{"start"} eq undef || $IN{"start"} eq "lastpage") {
        $IN{"start"}=int($records/$IN{"limit"})*$IN{"limit"};
      } else {
        $IN{"start"}=$records if $IN{"start"}>$records;
        $IN{"start"}=1 if $IN{"start"}<1;
      }
      $max=$IN{"start"}+$IN{"limit"};
      $max=$records if $max>$records;
  
      # print "<BR>start=$IN{'start'}, limit=$IN{'limit'}<BR>\n";
   
      # links to pages 1..xx
      print "Pages: ";
      $page=1;
      for($i=1;$i<=$records+1;$i+=$IN{"limit"}) {
        if($i>=$IN{"start"} && $i<$IN{"start"}+$IN{"limit"}) {
          print " <B>$page</B> ";
        } else {
          print " ",&callMe("start=$i&max=",$page)," ";
        }
        $page++;
      }
  
      print "<HR>\n";
      print "<FORM ACTION=\"$POSTINO{'AdminURL'}\" METHOD=post>\n";
      print "<INPUT TYPE=hidden NAME=archive VALUE=\"$IN{'archive'}\">\n";
      print "<INPUT TYPE=hidden NAME=do VALUE=\"Modify records\">\n";
      print "<INPUT TYPE=submit NAME=view VALUE=View>\n";
      print ": ";
      print "<INPUT TYPE=hidden NAME=limit VALUE=$IN{'limit'}>\n";
      print " from ";
      print "<INPUT TYPE=text NAME=start VALUE=$IN{'start'} SIZE=3>\n";
      print " to "; 
      print "<INPUT TYPE=text NAME=max VALUE=$max SIZE=3>\n";
      print " on ";
      print "<B>$records</B> records.</FORM>\n";
      print "<FORM ACTION=\"$POSTINO{'AdminURL'}\" METHOD=post>\n";
      print "<INPUT TYPE=hidden NAME=archive VALUE=\"$IN{'archive'}\">\n";
      print "<INPUT TYPE=hidden NAME=do VALUE=\"Modify records\">\n";
      print "<INPUT TYPE=submit NAME=view VALUE=View>\n";
      print " File: ";
      print "<INPUT TYPE=text NAME=file VALUE=\"\"></FORM>\n";
      print "<HR>\n";
  
      &execSQL("SELECT * FROM $ARCHIVE{'DB_Table'} ".
               " WHERE $ARCHIVE{'DB_Field_IDs'}<=$max ".
               " AND $ARCHIVE{'DB_Field_IDs'}>=$IN{'start'};");
      while($DB->FetchRow()) {
        %msg=$DB->DataHash();
        printf("%02d/%02d/%02d %02d:%02d ",$msg{$ARCHIVE{'DB_Field_Days'}},
	                                       $msg{$ARCHIVE{'DB_Field_Months'}},
										   $msg{$ARCHIVE{'DB_Field_Years'}},
										   $msg{$ARCHIVE{'DB_Field_Hours'}},
										   $msg{$ARCHIVE{'DB_Field_Minutes'}});
        print &callMe("number=$msg{$ARCHIVE{'DB_Field_IDs'}}",$msg{$ARCHIVE{'DB_Field_Subjects'}});
        print " - <I>$msg{$ARCHIVE{'DB_Field_Names'}}</I><BR>\n";
      }
    }
    $DB->Close();
    &benchmark();
  }
  exit(0);
}

######################################################################
# .A:SUBROUTINES
######################################################################

#===============
sub printDEBUG {
#===============
  local(@s)=@_;
  if($DEBUG ne undef) {
    foreach $elem (@s) {
      print "<FONT COLOR=blue>",$elem,"</FONT>";
    }
  }
}

#=============
sub dieERROR {
#=============
  local(@s)=@_;
  print "</FORM></TABLE>\n";
  foreach $elem (@s) {
    print "<HR><FONT COLOR=red>ERROR</FONT>: ",$elem,"<BR>$!<P></BODY></HTML>";
  }
  exit(0);
}

#===============
sub printERROR {
#===============
  local(@s)=@_;
  foreach $elem (@s) {
    print "<HR><FONT COLOR=red>ERROR</FONT>: ",$elem,"<BR><P>";
  }
}


#=================
sub emailConvert {
#=================
  # ACCEPTS A STRING IN THE "From: " HEADER FORMAT
  # AND RETURNS A LIST CONTAINING (name,email)
  local($line)=$_;
  local $email,$name,$oldname,$newname;

  # parse_address is (C) 1992 Raphael Manfredi
  ($email,$name)=&parse_address($line);
  $name=$email if $name eq undef;

  # this was my method... but there are better ways
  #if($line=~/^.* \<.*\>/) {
  #  $email=$line;
  #  $email=~s/^.* \<(.*)\>/$1/;
  #  $name=$line;
  #  $name=~s/^(.*) \<.*\>/$1/;
  #} elsif($line=~/^.* \(.*\)/) {
  #  $email=$line;
  #  $email=~s/^([^(]*) \(.*\)/$1/;
  #  $name=$line;
  #  $name=~s/$email//;
  #  $name=~s/^ *\(//;
  #  $name=~s/\) *$//;
  #} else {
  #  $name=$line;
  #  $email=$line;
  #}

  $name=~s/"//g;
  $name=~s/^\s*//;
  $name=~s/\s*$//;

  # ISO-8859 characters conversion
  # I'm going on for examples (when I find a new char, I add it here...)
  if($name=~/^=\?iso-8859-\d\?Q\?/i) {
    $name=~s/^=\?iso-8859-\d\?Q\?//i;
    $name=~s/=F8/\&oslash;/gi;
    $name=~s/=D8/\&Oslash;/gi;
    $name=~s/\?=\s*$//;
  }

  # unify users with many names 
  # see the <A HREF="#ALIASES>aliases</A> section
  foreach $oldname (keys(%ALIASES)) {
    $newname=$ALIASES{$oldname};
    $name=~s/^$oldname$/$newname/i;
  }
  # return "<A HREF=\"mailto:".$email."\">".$name."</A>";

  return($name,$email);

}

#================
sub dateConvert {
#================
  # ACCEPTS A STRING IN THE "Date: " HEADER FORMAT
  # AND RETURNS A LIST CONTAINING (YY,MM,DD,hh,mm)
  local($file,$line)=@_;
  local $day,$month,$year,$date,$hour,$minute;

  # parse_date is (C) 1995,6 Earl Hood, ehood@isogen.com
  ($day,$month,$year,$hour,$minute,$tz)=&parse_date($line);
  $year-=1900 if $year>100;
  $tz="GMT" if $tz eq undef;
  ($year,$month,$day,$hour,$minute)=&timezoneConvert($year,$month,$day,$hour,$minute,$tz,$file);
  return($year,$month,$day,$hour,$minute);
  # return sprintf("%02d/%02d/%02d %02d:%02d",$day,$month,$year,$hour,$minute);
}


#====================
sub timezoneConvert {
#====================
  local($year,$month,$day,$hour,$minute,$tz,$file)=@_;
  local $tzsign,$tzhour,$tzminute;
  &printDEBUG("got TZ=<TT>[$tz]</TT>");
  local $gotcha=0;

  study $tz;

  # first try if it is an offset (eg. -0700)...
  
    $tz=~/[^+-]*([+-])(\d\d)(\d\d)[^\d]*/;
    if($1 && $2 && $3) {
      $tzsign=$1;
      $tzhour=$2;
      $tzminute=$3;
      $tzhour=-$tzhour if $tzsign eq "+";
      $tzminute=-$tzminute if $tzsign eq "+";
      $hour+=$tzhour;
      $minute+=$tzminute;
      $gotcha=1;
      &printDEBUG("TZ was an offset! ");
    }


  # then try known timezones...
  if($gotcha==0) {
    $counter=0;
    while($gotcha==0 && $counter<$#KNOWN_TIMEZONES) {
      $TZ=@KNOWN_TIMEZONES[$counter++];
      &printDEBUG("checking if is it [$TZ]...");
      if($tz=~/$TZ/i) {
        $hour+=$TIMEZONES{$TZ}->[0];
        $minute+=$TIMEZONES{$TZ}->[1];
        $gotcha=1;
        &printDEBUG("YES! ");
      } else {
        &printDEBUG("NOT ");
      }
    }
  }
    
  # last resource...
  if($gotcha==0 && $tz=~/([+-])(\d)GMT/) {
    $tzhour="-" if $1 eq "+";
    $tzhour.=$2;
    $tzhour=-$tzhour if $tzsign eq "+";
    $gotcha=1;
    &printDEBUG("TZ was an insane GMT offset! ");
  }

  print "WARNING: unrecognized timezone: \"$tz\" in file \"$file\"! " if $gotcha==0;

  if($minute<0) { $hour--; $minute+=60; }
  if($minute>59) { $hour++; $minute-=60; }
  if($hour<0) { $day--; $hour+=24; }
  if($hour>23) { $day++; $hour-=24; }
  local @dom=(31,28,31,30,31,30,31,31,30,31,30,31);
  if($day>@dom[$month-1]) { $day=$day-@dom[$month-1]; $month++; }
  if($day<1) { $month--; $day=@dom[$month-1]-$day; }
  if($month<1) { $month=12; $year--; }
  if($month>12) { $month=12; $year++; }
  return($year,$month,$day,$hour,$minute);
}

#
# HTML SNIPPETS
#

#======================
sub printDoneWithHead {
#======================
  print "</TITLE></HEAD>$POSTINO{'HTML_Body'}\n";
}

#===================
sub printTitleLine {
#===================
  local($text)=@_ if @_;
  print "$POSTINO{'HTML_TitleFont'}$POSTINO{'HTML_Title'}$POSTINO{'HTML_TitleEnd'} - $text$POSTINO{'HTML_TitleFontEnd'}<HR>\n";
}

#==============
sub benchmark {
#==============
  local $Time=time-$^T;
  print "<HR><FONT FACE=Arial SIZE=1>Time: <B>$Time</B> ";
  print " - $POSTINO{'HTML_Title'} $POSTINO{'Version'} ";
  print " by <A HREF=\"mailto:$POSTINO{'Contact'}\">$POSTINO{'Author'}</A>\n";
  print "</FONT><P></BODY></HTML>";
}

#===========
sub callMe {
#===========
  local($string,$text) = @_;
  local @keys;
  local $elem;
  local $ret="";
  $ret=$ret."<A HREF=\"$POSTINO{'AdminURL'}\?".$string;
  foreach $elem (keys(%IN)) {
    next if (index($string,$elem."=") ne -1 || $IN{$elem} eq undef);
    $val=$IN{$elem};
    $val=~s/ /+/g;
    $ret=$ret."\&".$elem."=".$val;
  }
  $ret=$ret."\">".$text."</A>";
  return $ret;
}


# ----------------------------------------------------------------------------------------
              ####   ###   ###  ##### ### #   #  ###    ####  ####   ###
              #   # #   # #       #    #  ##  # #   #   #   # #   # #   #
              #   # #   #  ###    #    #  # # # #   #   #   # #   # #   #
              ####  #   #     #   #    #  #  ## #   #   ####  ####  #   #
              #     #   # #   #   #    #  #   # #   #   #     #  #  #   #
              #      ###   ###    #   ### #   #  ###    #     #   #  ###
# ----------------------------------------------------------------------------------------


#========================================
sub PostinoConnectToODBC {
#========================================
  local $ErrNum,$ErrText,$ErrConn;
  if (!($DB = new Win32::ODBC($ARCHIVE{'DB_DSN'}))){
    print "</TABLE></FORM><HR>\n";
    print "<FONT COLOR=red>ERROR</FONT> opening ODBC connection.<BR>\n";
    ($ErrNum, $ErrText, $ErrConn)=$DB->Error();
    print "[$ErrNum] $ErrText<HR>\n";
    exit();
  }
}


#============
sub execSQL {
#============
  local($sql)=@_;
  local $sqlret;
  #local $sql="";
  #foreach $l (@sqll) {
  #  $sql.=$l;
  #}
  $sqlret=$DB->Sql($sql);
  if($sqlret ne undef) {
    print "<FONT COLOR=indianred>SQL:</FONT> <B>$sql</B><BR>\n";
    print "<B><FONT COLOR=red>ERROR</FONT></B> \n";
    ($ErrNum, $ErrText, $ErrConn)=$DB->Error();
    print "$ErrText<BR>\n";
  } else {
    &printDEBUG("SQL: no errors doing <B>$sql</B><BR>\n");
  }
}


#===============
sub getRecords {
#===============
  local($field)=@_;
  local @work=();
  local $w;
  while($DB->FetchRow()) {
    $w=$DB->Data($field);
    &printDEBUG("$field=",$w,"<BR>");
    push(@work,$w);
  }
  return @work;
}


#================
sub PostinoInit {
#================
  local $result,$value,$values;
  $result=$main::HKEY_LOCAL_MACHINE->Open("SOFTWARE\\dada\\POSTINO",$REG) || return -1;
  $result=$REG->GetValues($values) || return -2;
  @getval=("Name","Version","Author","Contact",
           "AdminURL","DefaultArchive",
           "HTML_Body","HTML_Title","HTML_TitleEnd",
           "HTML_Font","HTML_FontEnd","HTML_TitleFont","HTML_TitleFontEnd",
           "IMG_Previous","IMG_Next","IMG_Void","IMG_Expand","IMG_Collapse");
  &PostinoGetRegistryValues($values,*POSTINO,@getval);
  $REG->Close();
  $POSTINO{'AdminURL'}=$ENV{'SCRIPT_NAME'} if $POSTINO{'AdminURL'} eq undef;
  return undef;
}


#=======================
sub PostinoLoadArchive {
#=======================
  local($archive)=@_;
  local $result,$value,$values;
  local @getval;

  if($archive ne "POSTINO") {
    $result=$main::HKEY_LOCAL_MACHINE->Open("SOFTWARE\\dada\\POSTINO\\Archives\\$archive",$REG) || return -1;
    $result=$REG->GetValues($values) || return -2;
    @getval=("DB_DSN","DB_Table","DB_Field_IDs","DB_Field_ParentIDs",
             "DB_Field_Years","DB_Field_Months","DB_Field_Days",
             "DB_Field_Hours","DB_Field_Minutes",
             "DB_Field_Subjects","DB_Field_Names","DB_Field_Emails",
             "DB_Field_Files","MSG_Path","MSG_Files","AliasFile",
			 "Name","HTML_File");
    &PostinoGetRegistryValues($values,*ARCHIVE,@getval);
  }
  @getval=("HTML_Body","HTML_Title","HTML_TitleEnd",
           "HTML_Font","HTML_FontEnd","HTML_TitleFont","HTML_TitleFontEnd",
           "IMG_Void","IMG_Expand","IMG_Collapse");
          
  &PostinoGetConditionalRegistryValues($values,*POSTINO,*ARCHIVE,@getval);

  $REG->Close();
  return undef;
}


#=============================
sub PostinoGetRegistryValues {
#=============================
  local($regkey,*store,@values)=@_;
  foreach $val (@values) {
    &printDEBUG($val,"=",$regkey->{$val}->[2],"<BR>\n");
    $store{$val}=$regkey->{$val}->[2];
  }
  return length($store);
}

#========================================
sub PostinoGetConditionalRegistryValues {
#========================================
  local($regkey,*from,*store,@values)=@_;

  foreach $val (@values) {
    if($regkey->{$val}->[2] ne undef) {
      $store{$val}=$regkey->{$val}->[2];
    } else {
      $store{$val}=$from{$val};
    }
  }
  return length($store);
}


#=======================
sub PostinoGetArchives {
#=======================
  local $result;
  local @archives;
  $result=$main::HKEY_LOCAL_MACHINE->Open("SOFTWARE\\dada\\POSTINO\\Archives",$REG) || return "Error";
  $result=$REG->GetKeys(\@archives) || return "Error";
  $REG->Close();
  return @archives;
}


#===================
sub RegUpdateValue {
#===================
  local($Key,$Values,$Name,$Type,$Value)=@_;
  local $aref;

  if($Type eq REG_DWORD && $Value ne ord($Values->{$Name}->[2])) {
    $Hresult=$_[0]->SetValueEx($Name,0,REG_DWORD,$Value) || &printERROR("Error setting registry value <B>$Name</B>!");
  }

  if($Type eq REG_SZ && $Value ne $Values->{$Name}->[2]) {
    $Hresult=$_[0]->SetValueEx($Name,0,REG_SZ,$Value) || &printERROR("Error setting registry value <B>$Name</B>!");
  }

}


#===================
sub RegCreateValue {
#===================
  local($Key,$Name,$Type,$Value)=@_;
  local $aref;

  if($Type eq REG_DWORD) {
    $Hresult=$_[0]->SetValueEx($Name,0,REG_DWORD,$Value) || &printERROR("Error setting registry value <B>$Name</B>!");
  }

  if($Type eq REG_SZ) {
    $Hresult=$_[0]->SetValueEx($Name,0,REG_SZ,$Value) || &printERROR("Error setting registry value <B>$Name</B>!");
  }

}


#=================
sub ConfigImages {
#=================
  local(*config)=@_;
  print "<B>Images:</B><BR>\n";
  print "<TABLE>\n";
  #print "<TD>$POSTINO{'HTML_Font'}Previous:</TD><TD><INPUT TYPE=text NAME=IMG_Previous VALUE=\"$config{'IMG_Previous'}\" SIZE=40>\n";
  #print "<IMG SRC=\"$config{'IMG_Previous'}\"></TD><TR>\n";
  #print "<TD>$POSTINO{'HTML_Font'}Next:</TD><TD><INPUT TYPE=text NAME=IMG_Next VALUE=\"$config{'IMG_Next'}\" SIZE=40>\n";
  #print "<IMG SRC=\"$config{'IMG_Next'}\"></TD><TR>\n";
  print "<TD>$POSTINO{'HTML_Font'}Expand:</TD><TD><INPUT TYPE=text NAME=IMG_Expand VALUE=\"$config{'IMG_Expand'}\" SIZE=40>\n";
  print "<IMG SRC=\"$config{'IMG_Expand'}\"></TD><TR>\n";
  print "<TD>$POSTINO{'HTML_Font'}Collapse:</TD><TD><INPUT TYPE=text NAME=IMG_Collapse VALUE=\"$config{'IMG_Collapse'}\" SIZE=40>\n";
  print "<IMG SRC=\"$config{'IMG_Collapse'}\"></TD><TR>\n";
  print "<TD>$POSTINO{'HTML_Font'}Void:</TD><TD><INPUT TYPE=text NAME=IMG_Void VALUE=\"$config{'IMG_Void'}\" SIZE=40>\n";
  print "<IMG SRC=\"$config{'IMG_Void'}\"></TD><TR>\n";
  print "</TABLE>\n";
  print "<P>\n";
}


#===============
sub ConfigHTML {
#===============
  local(*config)=@_;
  print "<B>HTML Output:</B><BR>\n";
  print "<TABLE>\n";
  &ConfigValueTextArea("Body","HTML_Body",*config);
  &ConfigValueTextArea("Title","HTML_Title",*config);
  print "<TD></TD><TD>$config{'HTML_TitleFont'}$config{'HTML_Title'}</TD><TR>\n";
  &ConfigValueTextArea("Title Font","HTML_TitleFont",*config);
  print "<TD></TD><TD>$config{'HTML_TitleFont'}Example</TD><TR>\n";
  &ConfigValueTextArea("Normal Font","HTML_Font",*config);
  print "<TD></TD><TD>$config{'HTML_Font'}Example</TD><TR>\n";
  print "</TABLE>\n";
  print "<P>\n";
}


#=============
sub ConfigDB {
#=============
  local(*config)=@_;
  print "<B>ODBC Connection:</B><BR>\n";
  print "<TABLE>\n";
  &ConfigValue("DSN","DB_DSN",*config);
  &ConfigValue("Table","DB_Table",*config);
  &ConfigValue("Field ID","DB_Field_IDs",*config);
  &ConfigValue("Field ParentID","DB_Field_ParentIDs",*config);
  &ConfigValue("Field Years","DB_Field_Years",*config);
  &ConfigValue("Field Months","DB_Field_Months",*config);
  &ConfigValue("Field Days","DB_Field_Days",*config);
  &ConfigValue("Field Hours","DB_Field_Hours",*config);
  &ConfigValue("Field Minutes","DB_Field_Minutes",*config);
  &ConfigValue("Field Subjects","DB_Field_Subjects",*config);
  &ConfigValue("Field Names","DB_Field_Names",*config);
  &ConfigValue("Field Emails","DB_Field_Emails",*config);
  &ConfigValue("Field Files","DB_Field_Files",*config);
  print "</TABLE>\n";
  print "<P>\n";
}


#================
sub ConfigValue {
#================
  local($title,$value,*config,$size)=@_;
  $size=40 if $size eq undef;
  print "<TD>$POSTINO{'HTML_Font'}$title:</TD>\n";
  print "<TD><INPUT TYPE=text NAME=$value VALUE=\"$config{$value}\" SIZE=$size></TD><TR>\n";
}


#========================
sub ConfigValueTextArea {
#========================
  local($title,$value,*config)=@_;
  print "<TD>$POSTINO{'HTML_Font'}$title:</TD>\n";
  print "<TD><TEXTAREA COLS=60 ROWS=0 NAME=$value>$config{$value}</TEXTAREA></TD><TR>\n";
}


#============
sub EndHTML {
#============
  local($HTML)=@_;
  local $return="";
  local %tags;
  local $tag;
  while($HTML=~s/<(FONT|B|I|U|S|SUB|SUP|TT|PRE|BLINK)[^>]*>/_Begin/i) { 
    $tags{$1}++ if $tags{$1} ne undef;
    $tags{$1}=1 if $tags{$1} eq undef;
  }
  while($HTML=~s/<\/(FONT|B|I|U|S|SUB|SUP|TT|PRE|BLINK)[^>]*>/_End/i) { 
    $tags{$1}-- if $tags{$1} ne undef;
    $tags{$1}=-1 if $tags{$1} eq undef;
  }

  foreach $tag (keys(%tags)) {
    while($tags{$tag}>0) {
      $return.="</$tag>";
      $tags{$tag}--;
    }
  }
  return $return; 
}    


#=======================
sub PostinoLoadAliases {
#=======================
  local (*a)=@_;
  local $from,$to;
  # read in the ALIASES (used by &emailConvert)
  # Aliases are read from the AliasFile
  # parameter of the archive
  # the format is "name > name", for example:
  #
  #  SIS > Aldo Calpini
  #  SIS - speedikon Italia Support > Aldo Calpini
  #  A. Calpini > Aldo Calpini
  #  dada > Aldo Calpini
  #  .
  #  .
  open(ALIASES,$ARCHIVE{'AliasFile'});
  while(<ALIASES>) {
    chop;
    ($from,$to)=split(/\s+>\s+/);
    $a{$from}=$to;
  }
  close(ALIASES);
  return length($a);
}

#
# THE NEXT SUBROUTINE WAS STOLEN FROM "cgi-lib.pl"
#==================================================
# Perl Routines to Manipulate CGI input
# S.E.Brenner@bioc.cam.ac.uk
# $Header: /cys/people/brenner/http/cgi-bin/RCS/cgi-lib.pl,v 1.8 1995/04/07 21:35:29 brenner Exp $
#
# Copyright 1994 Steven E. Brenner  
# For more information, see:
#     http://www.bio.cam.ac.uk/web/form.html       
#     http://www.seas.upenn.edu/~mengwong/forms/   
sub ReadParse {
  local (*in) = @_ if @_;
  local ($i, $key, $val);

  # Read in text
  if ($ENV{'REQUEST_METHOD'} eq "GET") {
    $in = $ENV{'QUERY_STRING'};
  } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
    read(STDIN,$in,$ENV{'CONTENT_LENGTH'});
  }

  @in = split(/&/,$in);

  foreach $i (0 .. $#in) {
    # Convert plus's to spaces
    $in[$i] =~ s/\+/ /g;

    # Split into key and value.  
    ($key, $val) = split(/=/,$in[$i],2); # splits on the first =.

    # Convert %XX from hex numbers to alphanumeric
    $key =~ s/%(..)/pack("c",hex($1))/ge;
    $val =~ s/%(..)/pack("c",hex($1))/ge;

    # Associate key and value
    $in{$key} .= "\0" if (defined($in{$key})); # \0 is the multiple separator
    $in{$key} .= $val;

  }

  return length($in); 
}

#
# THE NEXT SUBROUTINE WAS STOLEN FROM "mhonarc"
#==============================================
##  File:        mhutil.pl
##  Author:      Earl Hood       ehood@isogen.com
##  Date:        Wed Apr 17 00:46:26 CDT 1996
##  Description: Utility routines for MHonArc
##---------------------------------------------------------------------------
##	parse_date takes a string date specified like the output of
##	date(1) into its components.
##
sub parse_date {
    local($date) = $_[0];
    local($wday, $mday, $mon, $yr, $time, $hr, $min, $sec, $zone);
    local(@array);

    $date =~ s/^\s*//;
    @array = split(' ', $date);
    if ($array[0] =~ /\d/) {        # DD Mon YY HH:MM:SS Zone
	($mday, $mon, $yr, $time, $zone) = @array;
    } elsif ($array[1] =~ /\d/) {   # Wdy DD Mon YY HH:MM:SS Zone
	($wday, $mday, $mon, $yr, $time, $zone) = @array;
    } else {                        # Wdy Mon DD HH:MM:SS Zone YYYY
	($wday, $mon, $mday, $time, $zone, $yr) = @array;
	if ($zone =~ /\d/) {        # No zone
	    $yr = $zone;
	    $zone = '';
	}
    }
    ($hr, $min, $sec) = split(/:/, $time);

    ($mday, $Month2Num{$mon}, $yr, $hr, $min, $zone);
}

#
# THE NEXT SUBROUTINE WAS STOLEN FROM "rfc822.pl"
#================================================
# $Id: rfc822.pl,v 2.9 92/07/14 16:50:42 ram Exp $
#  Copyright (c) 1992, Raphael Manfredi
#
sub parse_address {
	local($_) = shift(@_);		# The address to be parsed
	local($comment);
	local($internet);
	if (/^\s*(\S+)\s+\((.*)\)/) {		# address (comment) 
		($1, $2);
	} elsif (/^\s*(.*)\s+<(\S+)>/) {	# comment <address>
		$comment = $1;
		$internet = $2;
		$comment =~ s/^"(.*)"/$1/;	# "comment" -> comment
		($internet, $comment);
	} elsif (/^\s*<(\S+)>/) {		# <address>
		($1, "");
	} else {				# address
		s/^\s+//;
		($_, "");
	}
}
